import { Component, ComponentEvent } from './AbstractComponent';
export interface AbstractItemView extends Component {
    resetState: (selected: boolean) => void;
    model: object;
}
export interface AbstractCollectionComponent extends Component {
    addChildView: <T extends AbstractItemView, Z extends object>(model: Z) => void;
    childViews: Array<AbstractItemView>;
    addViewEventListeners: () => void;
    addViewEventListener: <T extends AbstractItemView>(view: T) => void;
    removeViewEventListener: <T extends AbstractItemView>(view: T) => void;
    removeViewEventListeners: () => void;
    cloneItemTemplate: <T extends HTMLElement>() => T;
    createChildView: <T extends AbstractItemView>(model: object) => T;
    onItemSelectedDeselect: (event: ComponentEvent) => void;
    selectedItem: AbstractItemView;
    removeAllChildViews: () => void;
    destroyChildViews: () => void;
    removeElement: () => void;
    removeChildView: () => void;
}
export declare const createItemView: (component: Component) => AbstractItemView;
export declare const createComponent: (component: Component) => AbstractCollectionComponent;
