"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AbstractComponent_1 = require("./AbstractComponent");
const compose_1 = require("ramda/es/compose");
// export public functions
exports.createComponent = (component) => {
    const clone = AbstractComponent_1.mixin(component, {
        onClick: null,
    });
    clone.onSkinPartAdded = (part) => {
        switch (part) {
            case 'button':
                // add button event listener or whatever else yo want to do when this skin part is added
                // you could hold until all skin parts are added and then call addEventListeners
                console.log(`Lotus.ButtonComponent.prototype.onSkinPartAdded: part: ${part}`);
                clone.skinPartMap.get(part).addEventListener('click', clone.onClick);
                break;
        }
    };
    clone.onClick = (event) => {
        console.log(`Lotus.ButtonComponent.prototype.onClick: event is ${event}`);
        console.log(`Lotus.ButtonComponent.prototype.onClick: my id is ${clone.id}`);
        clone.dispatch(AbstractComponent_1.getComponentEvent(AbstractComponent_1.Events.CLICK, { target: clone, originalEvent: event }));
    };
    clone.removeEventListeners = () => {
        if (clone.skinPartMap.get('button')) {
            clone.skinPartMap.get('button').removeEventListener('click', clone.onClick);
        }
    };
    return clone;
};
// create hook using compose
// hooks provide prebuilt functions that are useful
exports.useButton = compose_1.default(exports.createComponent, AbstractComponent_1.createComponent);
//# sourceMappingURL=Button.js.map